//+------------------------------------------------------------------+
//|                                  Expert main module - Strategy 2 |
//|                               Copyright (c) 2012-2014 Roman Rich |
//|                       |
//+------------------------------------------------------------------+
#property            version                 "1.01"
#property            link                    "https://www.facebook.com/roman.i.rich"
#property            copyright               "Copyright (c) 2012-2014 Roman Rich"
#property            description             " 2:"
#property            description             "    /"
#property            description             "  SL - "
#property            description             "  TP - "
#property            description             "  Trail -   /"
//---  
#include             "symbol_list_2.mqh"
//---
int                  bars_count;             //                                               
double               spread;                 // 
//---
int                  count_1;                // 
int                  count_2;                // 
int                  count_3;                // 
double               temp_1;                 //  
int                  temp_2;                 //  
//---
datetime             date_time[];            //       
double               price_open[];           //       
double               price_high[];           //       
double               price_low[];            //       
double               price_close[];          //       
ulong                volumes[];              //      
//---
uint                 symbol_digit=4;         //      
uint                 digit_2_orders;         //      
int                  symbols_total;          //    MarketWatch
int                  market_watch_symbol;    //    MarketWatch
//---
datetime             prev_bar_time_dig[1];   //       
datetime             cur_bar_time_dig[1];    //       
//---
MqlDateTime          prev_bar_time_struct;   //       
MqlDateTime          cur_bar_time_struct;    //       
MqlTradeRequest      trade_request;          //  
MqlTradeCheckResult  trade_check;            //    
MqlTradeResult       trade_result;           //   
MqlTick              last_tick;              //  
//---
string               company;                // - 
string               account;                //  
string               file_name;              //  
int                  handle;                 //   
string               symbol;                 //  
double               calc_margin;            //  
double               order_vol;              //   
ulong                ticket=0;               //  /
//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
struct PNF_CHART
  {
   uint              column_num;             //  
   datetime          last_date_time;         // /    
   uchar             column_type;            //  :   
   double            min_column_price;       //    
   double            max_column_price;       //    
   ulong             column_volume;          //   
   double            supp_price;             //    
   double            resist_price;           //    
  };
//---   
PNF_CHART pnf[];
//---
int                  column_count;           //   
double               double_box;             //    
double               start_min;              //        
double               start_max;              //        
double               cur_min;                //       
double               cur_max;                //       
double               rev_min;                //     ,      
double               rev_max;                //     ,      
double               cont_min;               //     ,     
double               cont_max;               //     ,     
ulong                cur_vol;                //   
uchar                cur_column;             //  :   
uchar                trend;                  //   : U  D
double               temp_minimum_price[];   //       
double               temp_maximum_price[];   //       
int                  order_col_number=0;     //  ,    
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
enum  BOX_SIZE
  {
   b_1=1,
   b_2=2,
   b_3=3,
   b_4=4,
   b_5=5,
   b_10=10,
   b_20=20,
   b_50=50,
   b_100=100,
   b_200=200,
   b_500=500
  };
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
enum  REVERSE_SIZE
  {
   one=1,
   two,
   three,
   four,
   five
  };
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
sinput string          delimiter_1="";                // ===  ===
input  bool            is_const_lot=true;             //   ?
input  double          risk=0.10;                     //  , %
input  double          opt_f=0.01;                    //   , %
sinput string          delimiter_2="";                // === ===
input  datetime        begin_of_test=D'2012.01.01';   //  
input  SYMBOLS         selected_symbol;               // 
input  ENUM_TIMEFRAMES time_frame=PERIOD_M1;          // 
input  ulong           magic=666;                     // Magic 
sinput string          delimiter_3="";                // === ===
input  BOX_SIZE        box=b_100;                     //     (2  4  )
input  REVERSE_SIZE    reverse=three;                 // , 
sinput string          delimiter_4="";                // === ===
//+------------------------------------------------------------------+
//|    OnInit()                             |
//|      /                                     |
//|                                                    |
//|      -                             |
//|                                      |
//+------------------------------------------------------------------+
int OnInit()
  {
//---   
   prev_bar_time_dig[0]=D'2001.01.01';
   TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
//---  
   if((MQLInfoInteger(MQL_TESTER)==true) || (MQLInfoInteger(MQL_OPTIMIZATION)==true))
      SelectSymbol();
   else
      symbol=Symbol();
//---      
   if(SymbolInfoInteger(symbol,SYMBOL_DIGITS)<=3)
      digit_2_orders=2;
   else
      digit_2_orders=4;
//---   
   CreatePNFArray();
//---  
   return(INIT_SUCCEEDED);
  };
//+------------------------------------------------------------------+
//|    OnTick()                               |
//|                   |
//|     ,     ?                           |
//|       ,     ,            |
//|         -,                           |
//|         ,                          |
//|          ?                      |
//+------------------------------------------------------------------+
void OnTick()
  {
//---   
   if(IsNewBar()==true)
     {
      RecalcIndicators();
      //---  /?
      if((MQLInfoInteger(MQL_TESTER)==true) || (MQLInfoInteger(MQL_OPTIMIZATION)==true))
        {
         //---    ?
         if(cur_bar_time_dig[0]>begin_of_test)
           {
            //---      
            if(PositionSelect(symbol)==true)
               //--- ,  -  SL,    - 
               TrailCondition();
            //---    
            else
            //--- , -  ,    - 
               TradeCondition();
           }
        }
      else
        {
         //---      
         if(PositionSelect(symbol)==true)
            //--- ,  -  SL,    - 
            TrailCondition();
         //---    
         else
         //--- , -  ,    - 
            TradeCondition();
        }

     };
  };
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+
double OnTester()
  {
   if(TesterStatistics(STAT_EQUITY_DDREL_PERCENT)>(risk*100))
      return(0);
   else
      return(NormalizeDouble(TesterStatistics(STAT_PROFIT),(uint)SymbolInfoInteger(symbol,SYMBOL_DIGITS)));
  };
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
void TradeCondition()
  {
   if(order_col_number!=column_count)
      //---  -   ?
     {
      if(OrdersTotal()>0)
        {
         //---  !
         for(int loc_count_1=0;loc_count_1<OrdersTotal();loc_count_1++)
           {
            ticket=OrderGetTicket(loc_count_1);
            if(!OrderSelect(ticket)) Print("Failed to select order #",ticket);
            if(OrderGetString(ORDER_SYMBOL)==symbol)
              {
               trade_request.order=ticket;
               trade_request.action=TRADE_ACTION_REMOVE;
               if(!OrderSend(trade_request,trade_result)) Print("Failed to send order #",trade_request.order);
              };
           };
         order_col_number=column_count;
         return;
        }
      else
        {
         order_col_number=column_count;
         return;
        }
     }
   else
   if(MathPow(10,pnf[column_count-1].resist_price)>SymbolInfoDouble(symbol,SYMBOL_ASK))
     {
      //---   BUY , ,      BUY     ?
      trade_request.price=NormalizeDouble(MathPow(10,pnf[column_count-1].resist_price),digit_2_orders);
      trade_request.sl=NormalizeDouble(MathPow(10,pnf[column_count-1].resist_price-(reverse-1)*double_box),digit_2_orders);
      trade_request.type=ORDER_TYPE_BUY_STOP;
      if(OrderSelect(ticket)==false)
         //--- ,    -  
        {
         PlaceOrder();
         order_col_number=column_count;
        }
      else
      //---    
        {
         //---         ?
         if((OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_SELL_STOP) || 
            ((OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_BUY_STOP) && (OrderGetDouble(ORDER_PRICE_OPEN)!=trade_request.price)))
           {
            //---       -  
            trade_request.order=ticket;
            trade_request.action=TRADE_ACTION_REMOVE;
            if(!OrderSend(trade_request,trade_result)) Print("Failed to send order #",trade_request.order);
            //---     
            PlaceOrder();
            order_col_number=column_count;
           };
        };
      return;
     }
   else
   if(MathPow(10,pnf[column_count-1].resist_price)<SymbolInfoDouble(symbol,SYMBOL_ASK))
     {
      //---   SELL , ,      SELL     ?
      trade_request.price=NormalizeDouble(MathPow(10,pnf[column_count-1].supp_price),digit_2_orders);
      trade_request.sl=NormalizeDouble(MathPow(10,pnf[column_count-1].supp_price+(reverse-1)*double_box),digit_2_orders);
      trade_request.type=ORDER_TYPE_SELL_STOP;
      if(OrderSelect(ticket)==false)
         //--- ,    -  
        {
         PlaceOrder();
         order_col_number=column_count;
        }
      else
      //---    
        {
         //---         ?
         if((OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_BUY_STOP) || 
            ((OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_SELL_STOP) && (OrderGetDouble(ORDER_PRICE_OPEN)!=trade_request.price)))
           {
            //---       -  
            trade_request.order=ticket;
            trade_request.action=TRADE_ACTION_REMOVE;
            if(!OrderSend(trade_request,trade_result)) Print("Failed to send order #",trade_request.order);
            //---     
            PlaceOrder();
            order_col_number=column_count;
           };
        };
      return;
     }
   else
      return;
  };
//+------------------------------------------------------------------+
//|      -              |
//+------------------------------------------------------------------+
void TrailCondition()
  {
   if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
      trade_request.sl=NormalizeDouble(MathMax(SymbolInfoDouble(symbol,SYMBOL_ASK),MathPow(10,pnf[column_count-1].max_column_price-reverse*double_box)),digit_2_orders);
   else
      trade_request.sl=NormalizeDouble(MathMin(SymbolInfoDouble(symbol,SYMBOL_BID),MathPow(10,pnf[column_count-1].min_column_price+reverse*double_box)),digit_2_orders);
   if(PositionGetDouble(POSITION_SL)!=trade_request.sl)
      PlaceTrailOrder();
  };
//+------------------------------------------------------------------+
//|        |
//+------------------------------------------------------------------+
void PlaceOrder()
  {
//---    
   uint digits_2_lot=(uint)SymbolInfoInteger(symbol,SYMBOL_DIGITS);
   double trade_risk=AccountInfoDouble(ACCOUNT_EQUITY)*opt_f;
   double one_tick_loss_min_lot=SymbolInfoDouble(symbol,SYMBOL_TRADE_TICK_VALUE_LOSS)*SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
//---    
   trade_request.magic=magic;
   trade_request.symbol=symbol;
   trade_request.action=TRADE_ACTION_PENDING;
   trade_request.tp=NULL;
   trade_request.comment=NULL;
   trade_request.type_filling=NULL;
   trade_request.stoplimit=NULL;
   trade_request.type_time=NULL;
   trade_request.expiration=NULL;
   if(is_const_lot==true)
     {
      order_vol=SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN);
     }
   else
     {
      order_vol=trade_risk/(MathAbs(trade_request.price-trade_request.sl)*MathPow(10,digits_2_lot)*one_tick_loss_min_lot)*SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP);
      order_vol=MathMax(order_vol,SymbolInfoDouble(symbol,SYMBOL_VOLUME_MIN));
      if(SymbolInfoDouble(symbol,SYMBOL_VOLUME_LIMIT)!=0) order_vol=MathMin(order_vol,SymbolInfoDouble(symbol,SYMBOL_VOLUME_LIMIT));
      order_vol=NormalizeDouble(order_vol,(int)MathAbs(MathLog10(SymbolInfoDouble(symbol,SYMBOL_VOLUME_STEP))));
     }
//---  
   while(order_vol>0)
     {
      trade_request.volume=MathMin(order_vol,SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX));
      if(!OrderSend(trade_request,trade_result)) Print("Failed to send order #",trade_request.order);
      order_vol=order_vol-SymbolInfoDouble(symbol,SYMBOL_VOLUME_MAX);
     };
   ticket=trade_result.order;
  };
//+------------------------------------------------------------------+
//|    -                            |
//+------------------------------------------------------------------+
void PlaceTrailOrder()
  {
   trade_request.magic=magic;
   trade_request.symbol=symbol;
   trade_request.action=TRADE_ACTION_SLTP;
   if(!OrderSend(trade_request,trade_result)) Print("Failed to send order #",trade_request.order);
  };
//+------------------------------------------------------------------+
//|                |
//+------------------------------------------------------------------+
void RecalcIndicators()
  {
//---        ,...
   CopyTime(symbol,time_frame,1,1,date_time);
   CopyHigh(symbol,time_frame,1,1,price_high);
   CopyLow(symbol,time_frame,1,1,price_low);
   CopyRealVolume(symbol,time_frame,1,1,volumes);
//--- 
   price_low[0]=NormalizeDouble(MathLog10(price_low[0]),symbol_digit);
   price_high[0]=NormalizeDouble(MathLog10(price_high[0]),symbol_digit);
   cur_min=MathNorm(price_low[0],double_box,true,symbol_digit);
   cur_max=MathNorm(price_high[0],double_box,false,symbol_digit);
   cur_vol=volumes[0];
//--- ...  PNF,...
   UpdatePNF();
//--- ...   PNF   -   ,...
   if(ArraySize(temp_minimum_price)!=column_count)
     {
      ArrayResize(temp_minimum_price,column_count,0);
      ArrayResize(temp_maximum_price,column_count,0);
      pnf[column_count-1].supp_price=0.0;
      pnf[column_count-1].resist_price=0.0;
     };
//--- ...  
   temp_minimum_price[column_count-1]=pnf[column_count-1].min_column_price;
   temp_maximum_price[column_count-1]=pnf[column_count-1].max_column_price;
   UpdateTrend();
  };
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void CreatePNFArray()
  {
   column_count=1;
   bars_count=MathMin(100000,Bars(symbol,time_frame));
   cur_column='.';
   trend='.';
//---   
   ArrayFree(pnf);
   ArrayFree(date_time);
   ArrayFree(price_high);
   ArrayFree(price_low);
   ArrayFree(volumes);
   ArrayFree(temp_minimum_price);
   ArrayFree(temp_maximum_price);
   ArrayResize(pnf,bars_count,0);
   ArrayResize(date_time,bars_count,0);
   ArrayResize(price_high,bars_count,0);
   ArrayResize(price_low,bars_count,0);
   ArrayResize(volumes,bars_count,0);
//---   
   CopyTime(symbol,time_frame,0,bars_count,date_time);
   CopyHigh(symbol,time_frame,0,bars_count,price_high);
   CopyLow(symbol,time_frame,0,bars_count,price_low);
   CopyRealVolume(symbol,time_frame,0,bars_count,volumes);
//--- 
   for(count_1=0;count_1<bars_count;count_1++)
     {
      price_low[count_1]=NormalizeDouble(MathLog10(price_low[count_1]),symbol_digit);
      price_high[count_1]=NormalizeDouble(MathLog10(price_high[count_1]),symbol_digit);
     };
//---   
   double_box=NormalizeDouble((double)box/MathPow(10.0,(double)symbol_digit),symbol_digit);
   start_min=MathNorm(price_low[0],double_box,true,symbol_digit);
   start_max=MathNorm(price_high[0],double_box,false,symbol_digit);
   cont_min=NormalizeDouble(start_min-double_box,symbol_digit);
   cont_max=NormalizeDouble(start_max+double_box,symbol_digit);
   rev_min=NormalizeDouble(start_max-reverse*double_box,symbol_digit);
   rev_max=NormalizeDouble(start_min+reverse*double_box,symbol_digit);
   cur_vol=volumes[0];
//---      
   pnf[column_count-1].column_num=column_count;
   pnf[column_count-1].column_type=cur_column;
   pnf[column_count-1].min_column_price=start_min;
   pnf[column_count-1].max_column_price=start_max;
   pnf[column_count-1].column_volume=cur_vol;
//---    -
   for(count_1=1;count_1<bars_count;count_1++)
     {
      cur_min=MathNorm(price_low[count_1],double_box,true,symbol_digit);
      cur_max=MathNorm(price_high[count_1],double_box,false,symbol_digit);
      cur_vol=volumes[count_1];
      UpdatePNF();
     };
//---   
//---     
   ArrayResize(temp_minimum_price,column_count,0);
   ArrayResize(temp_maximum_price,column_count,0);
   for(count_2=0;count_2<column_count;count_2++)
     {
      pnf[count_2].supp_price=0.0;
      pnf[count_2].resist_price=0.0;
      temp_minimum_price[count_2]=pnf[count_2].min_column_price;
      temp_maximum_price[count_2]=pnf[count_2].max_column_price;
     }
//---       (   )
   if(trend=='U')
     {
      pnf[0].supp_price=NormalizeDouble(temp_minimum_price[0]-double_box,symbol_digit);
      pnf[0].resist_price=0.0;
     }
   else
     {
      pnf[0].supp_price=0.0;
      pnf[0].resist_price=NormalizeDouble(temp_maximum_price[0]+double_box,symbol_digit);
     }
   count_2=count_3=1;
   while(count_2<column_count)
      CalcTrend();
//---         1
   ArrayFree(date_time);
   ArrayFree(price_high);
   ArrayFree(price_low);
   ArrayFree(volumes);
   ArrayResize(date_time,1,0);
   ArrayResize(price_high,1,0);
   ArrayResize(price_low,1,0);
   ArrayResize(volumes,1,0);
  };
//+------------------------------------------------------------------+
//|                         |
//+------------------------------------------------------------------+
void UpdatePNF()
  {
   switch(cur_column)
     {
      //---      ,    :   
      case '.':
        {
         //---        ,      Down
         if(cur_max>=rev_max)
           {
            cur_column='X';
            cont_max=NormalizeDouble(cur_max+double_box,symbol_digit);
            rev_min=NormalizeDouble(cur_max-reverse*double_box,symbol_digit);
            trend='D';
            pnf[column_count-1].column_volume=pnf[column_count-1].column_volume+cur_vol;
            pnf[column_count-1].column_type=cur_column;
            pnf[column_count-1].max_column_price=cur_max;
            break;
           };
         //---         ,      Up
         if(cur_min<=rev_min)
           {
            cur_column='O';
            cont_min=NormalizeDouble(cur_min-double_box,symbol_digit);
            rev_max=NormalizeDouble(cur_min+reverse*double_box,symbol_digit);
            trend='U';
            pnf[column_count-1].column_volume=pnf[column_count-1].column_volume+cur_vol;
            pnf[column_count-1].column_type=cur_column;
            pnf[column_count-1].min_column_price=cur_min;
            break;
           };
         break;
        };
      //---  ,   
      case 'X':
        {
         //---      
         if(cur_max>=cont_max)
           {
            cont_max=NormalizeDouble(cur_max+double_box,symbol_digit);
            rev_min=NormalizeDouble(cur_max-reverse*double_box,symbol_digit);
            pnf[column_count-1].column_volume=pnf[column_count-1].column_volume+cur_vol;
            pnf[column_count-1].max_column_price=cur_max;
            break;
           };
         //---    -    
         if(cur_min<=rev_min)
           {
            cur_column='O';
            column_count++;
            cont_min=NormalizeDouble(cur_min-double_box,symbol_digit);
            rev_max=NormalizeDouble(cur_min+reverse*double_box,symbol_digit);
            pnf[column_count-1].column_num=column_count;
            pnf[column_count-1].column_volume=cur_vol;
            pnf[column_count-1].column_type=cur_column;
            pnf[column_count-1].min_column_price=cur_min;
            pnf[column_count-1].max_column_price=NormalizeDouble(pnf[column_count-2].max_column_price-double_box,symbol_digit);
            break;
           };
         break;
        };
      //---   ,   
      case 'O':
        {
         //---      
         if(cur_min<=cont_min)
           {
            cont_min=NormalizeDouble(cur_min-double_box,symbol_digit);
            rev_max=NormalizeDouble(cur_min+reverse*double_box,symbol_digit);
            pnf[column_count-1].column_volume=pnf[column_count-1].column_volume+cur_vol;
            pnf[column_count-1].min_column_price=cur_min;
            break;
           };
         //---    -    
         if(cur_max>=rev_max)
           {
            cur_column='X';
            column_count++;
            cont_max=NormalizeDouble(cur_max+double_box,symbol_digit);
            rev_min=NormalizeDouble(cur_max-reverse*double_box,symbol_digit);
            pnf[column_count-1].column_num=column_count;
            pnf[column_count-1].column_volume=cur_vol;
            pnf[column_count-1].column_type=cur_column;
            pnf[column_count-1].min_column_price=NormalizeDouble(pnf[column_count-2].min_column_price+double_box,symbol_digit);
            pnf[column_count-1].max_column_price=cur_max;
            break;
           };
         break;
        };
     };
  };
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
void CalcTrend()
  {
   switch(trend)
     {
      //---   - Up
      case 'U':
        {
         temp_1=NormalizeDouble(pnf[count_2-1].supp_price+double_box,symbol_digit);
         //---       
         if(temp_1<temp_minimum_price[count_2])
           {
            pnf[count_2].supp_price=temp_1;
            count_2++;
            break;
           }
         //---    -   Down
         else
           {
            pnf[count_2].supp_price=-10.0;
            trend='D';
            count_3=ArrayMaximum(temp_maximum_price,count_3,count_2-count_3);
            temp_2=count_3;
            temp_1=NormalizeDouble(temp_maximum_price[count_3]+double_box,symbol_digit);
            while(count_3<count_2)
              {
               if(temp_1>temp_maximum_price[count_3])
                 {
                  count_3++;
                  temp_1=NormalizeDouble(temp_1-double_box,symbol_digit);
                 }
               else
                 {
                  count_3=ArrayMaximum(temp_maximum_price,count_3,count_2-count_3);
                  temp_2=count_3;
                  temp_1=NormalizeDouble(temp_maximum_price[count_3]+double_box,symbol_digit);
                 };
              };
            count_3=temp_2;
            temp_1=NormalizeDouble(temp_maximum_price[count_3]+double_box,symbol_digit);
            pnf[count_3].resist_price=temp_1;
            count_3++;
            while(count_3<=count_2)
              {
               temp_1=NormalizeDouble(pnf[count_3-1].resist_price-double_box,symbol_digit);
               pnf[count_3].resist_price=temp_1;
               count_3++;
              }
            count_3=temp_2;
            count_2++;
            break;
           };
        };
      //---   - Down
      case 'D':
        {
         temp_1=NormalizeDouble(pnf[count_2-1].resist_price-double_box,symbol_digit);
         //---       
         if(temp_1>temp_maximum_price[count_2])
           {
            pnf[count_2].resist_price=temp_1;
            count_2++;
            break;
           }
         //---    -   Up
         else
           {
            pnf[count_2].resist_price=-10.0;
            trend='U';
            count_3=ArrayMinimum(temp_minimum_price,count_3,count_2-count_3);
            temp_2=count_3;
            temp_1=NormalizeDouble(temp_minimum_price[count_3]-double_box,symbol_digit);
            while(count_3<count_2)
              {
               if(temp_1<temp_minimum_price[count_3])
                 {
                  count_3++;
                  temp_1=NormalizeDouble(temp_1+double_box,symbol_digit);
                 }
               else
                 {
                  count_3=ArrayMinimum(temp_minimum_price,count_3,count_2-count_3);
                  temp_2=count_3;
                  temp_1=NormalizeDouble(temp_minimum_price[count_3]-double_box,symbol_digit);
                 };
              };
            count_3=temp_2;
            temp_1=NormalizeDouble(temp_minimum_price[count_3]-double_box,symbol_digit);
            pnf[count_3].supp_price=temp_1;
            count_3++;
            while(count_3<=count_2)
              {
               temp_1=NormalizeDouble(pnf[count_3-1].supp_price+double_box,symbol_digit);
               pnf[count_3].supp_price=temp_1;
               count_3++;
              }
            count_3=temp_2;
            count_2++;
            break;
           };
        };
     };
  };
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void UpdateTrend()
  {
   switch(trend)
     {
      //---   - Up
      case 'U':
        {
         temp_1=NormalizeDouble(pnf[column_count-2].supp_price+double_box,symbol_digit);
         //---       
         if(temp_1<temp_minimum_price[column_count-1])
           {
            pnf[column_count-1].supp_price=temp_1;
            break;
           }
         //---    -   Down
         else
           {
            pnf[column_count-1].supp_price=-10.0;
            trend='D';
            count_3=ArrayMaximum(temp_maximum_price,count_3,column_count-1-count_3);
            temp_2=count_3;
            temp_1=NormalizeDouble(temp_maximum_price[count_3]+double_box,symbol_digit);
            while(count_3<column_count-1)
              {
               if(temp_1>temp_maximum_price[count_3])
                 {
                  count_3++;
                  temp_1=NormalizeDouble(temp_1-double_box,symbol_digit);
                 }
               else
                 {
                  count_3=ArrayMaximum(temp_maximum_price,count_3,column_count-1-count_3);
                  temp_2=count_3;
                  temp_1=NormalizeDouble(temp_maximum_price[count_3]+double_box,symbol_digit);
                 };
              };
            count_3=temp_2;
            temp_1=NormalizeDouble(temp_maximum_price[count_3]+double_box,symbol_digit);
            pnf[count_3].resist_price=temp_1;
            count_3++;
            while(count_3<=column_count-1)
              {
               temp_1=NormalizeDouble(pnf[count_3-1].resist_price-double_box,symbol_digit);
               pnf[count_3].resist_price=temp_1;
               count_3++;
              }
            count_3=temp_2;
            break;
           };
        };
      //---   - Down
      case 'D':
        {
         temp_1=NormalizeDouble(pnf[column_count-2].resist_price-double_box,symbol_digit);
         //---       
         if(temp_1>temp_maximum_price[column_count-1])
           {
            pnf[column_count-1].resist_price=temp_1;
            break;
           }
         //---    -   Up
         else
           {
            pnf[column_count-1].resist_price=-10.0;
            trend='U';
            count_3=ArrayMinimum(temp_minimum_price,count_3,column_count-1-count_3);
            temp_2=count_3;
            temp_1=NormalizeDouble(temp_minimum_price[count_3]-double_box,symbol_digit);
            while(count_3<column_count-1)
              {
               if(temp_1<temp_minimum_price[count_3])
                 {
                  count_3++;
                  temp_1=NormalizeDouble(temp_1+double_box,symbol_digit);
                 }
               else
                 {
                  count_3=ArrayMinimum(temp_minimum_price,count_3,column_count-1-count_3);
                  temp_2=count_3;
                  temp_1=NormalizeDouble(temp_minimum_price[count_3]-double_box,symbol_digit);
                 };
              };
            count_3=temp_2;
            temp_1=NormalizeDouble(temp_minimum_price[count_3]-double_box,symbol_digit);
            pnf[count_3].supp_price=temp_1;
            count_3++;
            while(count_3<=column_count-1)
              {
               temp_1=NormalizeDouble(pnf[count_3-1].supp_price+double_box,symbol_digit);
               pnf[count_3].supp_price=temp_1;
               count_3++;
              }
            count_3=temp_2;
            break;
           };
        };
     };
  };
//+------------------------------------------------------------------+
//|     :                                   |
//|      double-    ,                    |
//|      true -  , false -  ,         |
//|                     |
//+------------------------------------------------------------------+
double MathNorm(double value,double var_box,bool vect,uint prec)
  {
   if(vect==true)
      return(NormalizeDouble(MathCeil(value/var_box)*var_box,prec));
   else
      return(NormalizeDouble(MathFloor(value/var_box)*var_box,prec));
  };
//+------------------------------------------------------------------+
//| ,                                  |
//+------------------------------------------------------------------+
bool IsNewBar()
  {
   CopyTime(symbol,time_frame,0,1,cur_bar_time_dig);
   TimeToStruct(cur_bar_time_dig[0],cur_bar_time_struct);
   if(time_frame==PERIOD_M1||
      time_frame==PERIOD_M2||
      time_frame==PERIOD_M3||
      time_frame==PERIOD_M4||
      time_frame==PERIOD_M5||
      time_frame==PERIOD_M6||
      time_frame==PERIOD_M10||
      time_frame==PERIOD_M12||
      time_frame==PERIOD_M15||
      time_frame==PERIOD_M20||
      time_frame==PERIOD_M30)
      if(cur_bar_time_struct.min!=prev_bar_time_struct.min)
        {
         prev_bar_time_dig[0]=cur_bar_time_dig[0];
         TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
         return(true);
        };
   if(time_frame==PERIOD_H1||
      time_frame==PERIOD_H2||
      time_frame==PERIOD_H3||
      time_frame==PERIOD_H4||
      time_frame==PERIOD_H6||
      time_frame==PERIOD_H8||
      time_frame==PERIOD_H12)
      if(cur_bar_time_struct.hour!=prev_bar_time_struct.hour)
        {
         prev_bar_time_dig[0]=cur_bar_time_dig[0];
         TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
         return(true);
        };
   if(time_frame==PERIOD_D1||
      time_frame==PERIOD_W1)
      if(cur_bar_time_struct.day!=prev_bar_time_struct.day)
        {
         prev_bar_time_dig[0]=cur_bar_time_dig[0];
         TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
         return(true);
        };
   if(time_frame==PERIOD_MN1)
      if(cur_bar_time_struct.mon!=prev_bar_time_struct.mon)
        {
         prev_bar_time_dig[0]=cur_bar_time_dig[0];
         TimeToStruct(prev_bar_time_dig[0],prev_bar_time_struct);
         return(true);
        };
   return(false);
  };
//+------------------------------------------------------------------+
